SystemOrganization addCategory: #'Xtreams-Support'!

!Exception class methodsFor: '*Xtreams-Support' stamp: 'nice 10/9/2010 22:59'!
raise
	^self signal! !

!Exception methodsFor: '*Xtreams-Support' stamp: 'nice 10/11/2010 23:53'!
originator
	^self signalerContext home receiver! !

!Exception methodsFor: '*Xtreams-Support' stamp: 'nice 10/9/2010 22:59'!
raise
	^self signal! !

SharedPool subclass: #XTPools
	instanceVariableNames: 'buffer'
	classVariableNames: 'CR DefaultBufferSize LF'
	poolDictionaries: ''
	category: 'Xtreams-Support'!

!XTPools commentStamp: 'nice 10/9/2010 19:21' prior: 0!
XTPools is a pool dictionary for storing Xtreams global variables.
Note that in VW original implementation, these variables are stored directly in the Xtreams namespace.!

!XTPools classSide methodsFor: 'class initialization' stamp: 'MartinKobetic 1/6/2011 22:30'!
initialize
	DefaultBufferSize := 32768.
	CR := Character cr.
	LF := Character lf.! !

!TextConverter methodsFor: '*Xtreams-Support' stamp: 'nice 10/13/2010 20:52'!
streamingAsEncoder

	^self! !

!SortedCollection methodsFor: '*Xtreams-Support' stamp: 'nice 10/9/2010 18:54'!
copyEmpty: aSize
	"Answer a copy of the receiver that contains no elements.

	This method should be redefined in subclasses that add
	instance variables, so that the state of those variables
	is preserved"

	^(super copyEmpty: aSize) sortBlock: sortBlock! !

!Symbol methodsFor: '*Xtreams-Support' stamp: 'nice 10/10/2010 15:28'!
cull: anObject 
	^anObject perform: self.! !

!Collection methodsFor: '*Xtreams-Support' stamp: 'nice 10/9/2010 18:53'!
copyEmpty: aSize
	"Answer a copy of the receiver that contains no elements.

	This method should be redefined in subclasses that add
	instance variables, so that the state of those variables
	is preserved"

	^self class new: aSize! !

!SequenceableCollection class methodsFor: '*Xtreams-Support-xtreams' stamp: 'MartinKobetic 12/30/2010 21:57'!
newInFixedSpaceRecycled: size

	^self error: 'Not Implemented'! !

!SequenceableCollection class methodsFor: '*Xtreams-Support-xtreams' stamp: 'MartinKobetic 1/1/2011 15:56'!
newInFixedSpaceRecycledDefaultSize

	^self error: 'Not Implemented'! !

!SequenceableCollection class methodsFor: '*Xtreams-Support-xtreams' stamp: 'MartinKobetic 12/30/2010 21:51'!
newRecycled: size

	^XTRecyclingCenter new: size class: self! !

!SequenceableCollection class methodsFor: '*Xtreams-Support-xtreams' stamp: 'MartinKobetic 1/1/2011 16:00'!
newRecycledAtLeast: size

	^self newRecycled: (size max: XTRecyclingCenter defaultBufferSize)! !

!SequenceableCollection class methodsFor: '*Xtreams-Support-xtreams' stamp: 'MartinKobetic 1/1/2011 16:00'!
newRecycledDefaultSize

	^self newRecycled: XTRecyclingCenter defaultBufferSize! !

!SequenceableCollection class methodsFor: '*Xtreams-Support' stamp: 'nice 10/9/2010 19:02'!
withSize: size 
	"In general, the argument to #new: refers to the capacity of the 
	collection that is created, not the size. For ArrayedCollections, the 
	two are synonymous, but for collections that support #add: and 
	#remove:, this is not true. 
	
	This method creates a collection with the specified capacity AND 
	size, filling in the elements of the collection with the default 
	element for the collection. 
	
	Some collection types such as LinkedList, Interval, and 
	SortedCollection, may be unable to support this protocol for one 
	reason or another."

	^self ofSize: size! !

!SequenceableCollection methodsFor: '*Xtreams-Support' stamp: 'nice 10/9/2010 23:14'!
growToAtLeast: requestedSize
	"NOTE: since becomeForward: is known to be inefficient, use parsimoniously."
	
	| bigger sz |
	(sz := self size) >= requestedSize
		ifTrue: [^self ].
	bigger := self grownBy: (sz max: requestedSize - sz).
	^self becomeForward: bigger! !

!SequenceableCollection methodsFor: '*Xtreams-Support-xtreams' stamp: 'MartinKobetic 12/30/2010 22:53'!
recycle

	XTRecyclingCenter recycle: self! !

!ByteArray class methodsFor: '*Xtreams-Support' stamp: 'nice 10/12/2010 01:51'!
fromHexString: aString
	^self readHexFrom: aString! !

Error subclass: #Incomplete
	instanceVariableNames: 'collection count start'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Support'!

!Incomplete commentStamp: 'nice 10/9/2010 21:44' prior: 0!
This error is raised when a read or write fails to complete. The parameters report the details about successfully written or read elements.

Instance Variables
	collection	<Collection | nil> when possible points at the collection with the successfully processed elements
	count	<Integer> number of successfully processed elements
	start	<Integer> if collection is set, this is the index where the successfully processed elements start

!

!Incomplete classSide methodsFor: 'instance creation' stamp: 'nice 10/9/2010 18:57'!
count: anInteger
	^self new on: nil count: anInteger at: nil! !

!Incomplete classSide methodsFor: 'instance creation' stamp: 'nice 10/9/2010 18:57'!
on: collection count: count at: start
	^self new on: collection count: count at: start! !

!Incomplete classSide methodsFor: 'instance creation' stamp: 'nice 10/9/2010 18:57'!
zero
	^self count: 0! !

!Incomplete methodsFor: 'accessing' stamp: 'nice 10/9/2010 18:58'!
collection
	^collection! !

!Incomplete methodsFor: 'accessing' stamp: 'nice 10/9/2010 18:58'!
collection: anObject
	collection := anObject! !

!Incomplete methodsFor: 'accessing' stamp: 'MartinKobetic 12/22/2010 16:42'!
contents
	^collection
		ifNil: [ self originator contentsSpecies withSize: count ]
		ifNotNil: [ collection copyFrom: start to: start + count - 1 ]! !

!Incomplete methodsFor: 'accessing' stamp: 'nice 10/9/2010 19:03'!
count
	^count! !

!Incomplete methodsFor: 'accessing' stamp: 'nice 10/9/2010 19:03'!
count: anObject
	count := anObject! !

!Incomplete methodsFor: 'initialize-release' stamp: 'nice 10/9/2010 19:10'!
on: aCollection count: aCount at: aStart
	collection := aCollection.
	count := aCount.
	start := aStart! !

!Incomplete methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
streamingInsert: anInteger into: aWriteStream
	| amount |
	collection ifNil: [(Incomplete on: collection count: 0 at: start) raise].
	amount := anInteger min: count.
	aWriteStream insert: amount from: collection at: start.
	amount < anInteger ifTrue: [(Incomplete on: collection count: amount at: start) raise].! !

!Incomplete methodsFor: 'private' stamp: 'nice 10/9/2010 19:11'!
streamingInsertInto: aWriteStream
	collection ifNil: [^0].
	aWriteStream insert: count from: collection at: start.
	^count! !

!Incomplete methodsFor: 'private' stamp: 'MartinKobetic 1/11/2011 17:53'!
streamingWrite: anInteger into: aWriteStream
	| amount |
	collection ifNil: [(Incomplete on: collection count: 0 at: start) raise].
	amount := anInteger min: count.
	aWriteStream write: amount from: collection at: start.
	amount < anInteger ifTrue: [(Incomplete on: collection count: amount at: start) raise].
	^anInteger! !

!Incomplete methodsFor: 'private' stamp: 'nice 10/9/2010 19:11'!
streamingWriteInto: aWriteStream
	collection ifNil: [^0].
	aWriteStream write: count from: collection at: start.
	^count! !

!Object methodsFor: '*Xtreams-Support' stamp: 'nice 10/9/2010 19:44'!
isFixedArgument
	"Answer if the receiver, when passed as an argument through the 
	 DLL & C Connect, represents data at a fixed address.  This is true
	 for objects created via the newInFixedSpace: primitive. Fail if the
	 receiver is immediate, since it has no data.  In this case the Smalltalk
	 code copes with the immediate case."

	^false! !

Object subclass: #XTEncoder
	instanceVariableNames: ''
	classVariableNames: 'DialectEncoder Encoders'
	poolDictionaries: ''
	category: 'Xtreams-Support'!

!XTEncoder commentStamp: 'nice 10/11/2010 21:57' prior: 0!
Abstract character encoder class defines the API and maintains a registry of known encoders (Encoders). Also provides a hook to allow plugging in dialect specific encoders (DialectEncoder) as a secondary encoder resource.

Shared Variables
	DialectEncoder	<Object> undocumented
	Encoders	<Object> undocumented

!

!XTEncoder classSide methodsFor: 'accessing' stamp: 'nice 10/13/2010 20:42'!
encoders

	^Encoders ifNil: [ Encoders := IdentityDictionary new ]! !

!XTEncoder classSide methodsFor: 'instance creation' stamp: 'nice 10/13/2010 20:46'!
for: anEncoding

	anEncoding isSymbol ifFalse: [ ^anEncoding streamingAsEncoder ].
	^Encoders at: anEncoding ifAbsent: [
		DialectEncoder
			ifNil: [ self error: 'Unknown encoding!!' ]
			ifNotNil: [ :factory | factory for: anEncoding ] ]! !

!XTEncoder methodsFor: 'accessing' stamp: 'nice 10/11/2010 21:57'!
backupState! !

!XTEncoder methodsFor: 'accessing' stamp: 'nice 10/11/2010 21:57'!
decodeFrom: aReadStream

	^self subclassResponsibility! !

!XTEncoder methodsFor: 'accessing' stamp: 'nice 10/11/2010 21:57'!
encode: aCharacter on: aWriteStream

	^self subclassResponsibility! !

!XTEncoder methodsFor: 'accessing' stamp: 'nice 10/11/2010 21:57'!
restoreState! !

!XTEncoder methodsFor: 'accessing' stamp: 'nice 10/11/2010 21:57'!
streamingAsEncoder

	^self! !

XTEncoder subclass: #XTSqueakEncoder
	instanceVariableNames: 'encoder skipRecord backupRecord'
	classVariableNames: 'TextConverterMap'
	poolDictionaries: ''
	category: 'Xtreams-Support'!

!XTSqueakEncoder classSide methodsFor: 'instance creation' stamp: 'nice 10/12/2010 00:11'!
for: anEncoding

	^self new encoding: anEncoding! !

!XTSqueakEncoder classSide methodsFor: 'class initialization' stamp: 'MartinKobetic 1/14/2011 01:21'!
initialize

	DialectEncoder := self.
	TextConverterMap := IdentityDictionary new.
	TextConverter withAllSubclassesDo: [:converterClass |
		converterClass encodingNames do: [: encodingName |
			TextConverterMap at: encodingName asSymbol put: converterClass]].! !

!XTSqueakEncoder methodsFor: 'accessing' stamp: 'nice 10/12/2010 00:21'!
decodeFrom: aReadStream

	^encoder nextFromStream: aReadStream! !

!XTSqueakEncoder methodsFor: 'accessing' stamp: 'nice 10/12/2010 00:21'!
encode: aCharacter on: aWriteStream

	^encoder nextPut: aCharacter toStream: aWriteStream! !

!XTSqueakEncoder methodsFor: 'accessing' stamp: 'nice 10/13/2010 20:19'!
encoding: anEncoding

	encoder := (TextConverterMap at: anEncoding) new.
	(encoder isKindOf: UTF16TextConverter) ifTrue: [ encoder useLittleEndian: false ]! !

Object subclass: #XTExternalResourceHandle
	instanceVariableNames: 'handle'
	classVariableNames: 'Registry'
	poolDictionaries: ''
	category: 'Xtreams-Support'!

!XTExternalResourceHandle commentStamp: 'nice 12/1/2009 20:09' prior: 0!
An ExternalResourceHandle is an abstract class for handling external resource from within the image through a handle.

This class offers a very basic API essentially for registering/unregistering/finalizing external resources.

Instance Variables:
	handle		<Object> the (obscure) object representing the external resource

Class variables:
	Registry	<WeakRegistry> a place where to register external resource in use!

!XTExternalResourceHandle classSide methodsFor: 'registry' stamp: 'nice 11/28/2009 14:56'!
register: anObject
	self registry add: anObject! !

!XTExternalResourceHandle classSide methodsFor: 'registry' stamp: 'nice 9/25/2010 00:15'!
registry
	^Registry ifNil: [Registry := WeakRegistry new]! !

!XTExternalResourceHandle classSide methodsFor: 'registry' stamp: 'nice 11/28/2009 14:55'!
retryWithGC: execBlock until: testBlock forFileNamed: fullName
	"Re-implemented to only force GC if a file with the given name exists"
	| blockValue foundIt |
	blockValue := execBlock value.
	(testBlock value: blockValue) ifTrue: [^blockValue].
	"See if we have a file with the given name"
	foundIt := Registry keys "hold on strongly for now" 
		anySatisfy: [:file| file name sameAs: fullName].
	foundIt ifFalse: [^blockValue].
	Smalltalk garbageCollectMost.
	blockValue := execBlock value.
	(testBlock value: blockValue) ifTrue: [^blockValue].
	Smalltalk garbageCollect.
	^execBlock value.! !

!XTExternalResourceHandle classSide methodsFor: 'registry' stamp: 'nice 11/28/2009 14:54'!
unregister: anObject
	self registry remove: anObject ifAbsent: []! !

!XTExternalResourceHandle methodsFor: 'finalization' stamp: 'nice 11/28/2009 15:06'!
finalize
	self unregister! !

!XTExternalResourceHandle methodsFor: 'accessing' stamp: 'nice 11/28/2009 20:24'!
handle
	^handle! !

!XTExternalResourceHandle methodsFor: 'accessing' stamp: 'nice 11/28/2009 20:24'!
handle: anObject
	handle := anObject! !

!XTExternalResourceHandle methodsFor: 'registry' stamp: 'nice 11/28/2009 14:57'!
register
	^self class register: self! !

!XTExternalResourceHandle methodsFor: 'registry' stamp: 'nice 11/28/2009 14:57'!
unregister
	^self class unregister: self! !

XTExternalResourceHandle subclass: #XTIOHandle
	instanceVariableNames: 'semaphore'
	classVariableNames: 'ConcreteFileClass ConcreteSocketClass RegistryThreshold'
	poolDictionaries: ''
	category: 'Xtreams-Support'!

!XTIOHandle commentStamp: 'dtl 11/28/2002 23:01' prior: 0!
I represent an external system input/output channel. My subclasses represent specific
kinds of IO channels, such as those for files or network connections.

I am responsible for primitive interfaces to an external object such as a file or network
socket. Other classes, such as FileStream or Socket subclasses, may collaborate to access
these primitives.

My subclasses are responsible for opening, closing, reading, writing, and controlling
various kinds of input/output channels. They may also maintain instance variables
which reflect the current state of an input/output channel.
!

XTIOHandle subclass: #XTIOFileHandle
	instanceVariableNames: 'writable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Support'!

!XTIOFileHandle commentStamp: 'dtl 11/28/2002 22:55' prior: 0!
I represent an IO channel on a file system object, such as a file. I keep a ByteArray
which corresponds to an SQFile data structure in the Squeak virtual machine.
!

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'dtl 12/27/2000 00:24'!
atEnd
	"Answer whether the receiver is at its end."

	^ self primAtEnd: self handle! !

!XTIOFileHandle methodsFor: 'open/close' stamp: 'MartinKobetic 1/16/2011 23:43'!
close
	"Close this file."

	self closed ifFalse: [ self primClose: self handle ]
! !

!XTIOFileHandle methodsFor: 'open/close' stamp: 'nice 9/25/2010 14:56'!
closeNoError
	"Close this file."

	self primCloseNoError: self handle
! !

!XTIOFileHandle methodsFor: 'testing' stamp: 'dtl 11/27/2002 20:07'!
closed
	"Answer true if this file closed."

	^ (self primSizeNoError: self handle) isNil! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'nice 10/14/2010 22:33'!
commit
	"Xtreams compatible message"
	^self primFlush: handle! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'nice 10/12/2010 02:33'!
fileSize
	"This is a Xtreams friendly message"

	^ self primSize: self handle! !

!XTIOFileHandle methodsFor: 'finalization' stamp: 'dtl 12/26/2000 17:02'!
finalize

	super finalize.
	self closeNoError
! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'dtl 11/27/2002 20:16'!
flush
	"Flush pending changes"
	^self primFlush: handle! !

!XTIOFileHandle methodsFor: 'open/close' stamp: 'nice 10/12/2010 20:48'!
open: fileName forWrite: writeMode 
	"Open the file with the given name. If writeMode is true, allow writing, otherwise
	open the file in read-only mode."

	self handle:
		((self primOpen: fileName writable: writeMode) ifNil: [^ nil]).  "allows sender to detect failure"
	writable := writeMode! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'dtl 12/27/2000 00:25'!
position
	"Return the receiver's current file position."

	^ self primGetPosition: self handle! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'dtl 12/27/2000 00:25'!
position: pos
	"Set the receiver's file position."

	^ self primSetPosition: self handle to: pos! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:21'!
primAtEnd: id
	"Answer true if the file position is at the end of the file."

	<primitive: 'primitiveFileAtEnd' module: 'FilePlugin'>
	self primitiveFailed
! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:21'!
primClose: id
	"Close this file."

	<primitive: 'primitiveFileClose' module: 'FilePlugin'>
	self primitiveFailed
! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:22'!
primCloseNoError: id
	"Close this file. Don't raise an error if the primitive fails."

	<primitive: 'primitiveFileClose' module: 'FilePlugin'>
! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/27/2002 20:14'!
primFlush: id
	"Flush pending changes to the disk"
	| p |
	<primitive: 'primitiveFileFlush' module: 'FilePlugin'>
	"In some OS's seeking to 0 and back will do a flush"
	p := self position.
	self position: 0; position: p! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:22'!
primGetPosition: id
	"Get this files current position."

	<primitive: 'primitiveFileGetPosition' module: 'FilePlugin'>
	self primitiveFailed
! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:23'!
primOpen: fileName writable: writableFlag
	"Open a file of the given name, and return the file ID obtained.
	If writableFlag is true, then
		if there is none with this name, then create one
		else prepare to overwrite the existing from the beginning
	otherwise
		if the file exists, open it read-only
		else return nil"

	<primitive: 'primitiveFileOpen' module: 'FilePlugin'>
	^ nil
! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:23'!
primRead: id into: byteArray startingAt: startIndex count: count
	"Read up to count bytes of data from this file into the given string or byte array starting at the given index. Answer the number of bytes actually read."

	<primitive: 'primitiveFileRead' module: 'FilePlugin'>
	self closed ifTrue: [^ self error: 'File is closed'].
	self error: 'File read failed'.
! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:23'!
primSetPosition: id to: anInteger
	"Set this file to the given position."

	<primitive: 'primitiveFileSetPosition' module: 'FilePlugin'>
	self primitiveFailed
! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:24'!
primSize: id
	"Answer the size of this file."

	<primitive: 'primitiveFileSize' module: 'FilePlugin'>
	self primitiveFailed
! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:24'!
primSizeNoError: id
	"Answer the size of this file. Answer nil if the primitive fails; this indicates that the file handle has become stale."

	<primitive: 'primitiveFileSize' module: 'FilePlugin'>
	^ nil
! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:14'!
primTruncate: id to: anInteger
	"Truncate this file to the given position."

	<primitive: 'primitiveFileTruncate' module: 'FilePlugin'>
	self primitiveFailed
! !

!XTIOFileHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:24'!
primWrite: id from: stringOrByteArray startingAt: startIndex count: count
	"Write count bytes onto this file from the given string or byte array starting at the given index. Answer the number of bytes written."

	<primitive: 'primitiveFileWrite' module: 'FilePlugin'>
	self closed ifTrue: [^ self error: 'File is closed'].
	self error: 'File write failed'.
! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'nice 10/14/2010 21:36'!
readInto: buffer
	"Answer the number of bytes read"
	^self primRead: self handle into: buffer startingAt: 1 count: buffer size! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'nice 9/25/2010 14:55'!
readInto: buffer startingAt: index count: num
	"Answer the number of bytes read"
	^self primRead: self handle into: buffer startingAt: index count: num! !

!XTIOFileHandle methodsFor: 'converting' stamp: 'nice 10/12/2010 03:10'!
reading
	^XTFileReadStream on: self! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'nice 10/12/2010 02:33'!
seekTo: pos
	"This is a Xtreams friendly message"

	^ self primSetPosition: self handle to: pos! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'dtl 12/27/2000 00:25'!
size
	"Answer the size of the file in characters."

	^ self primSize: self handle! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'dtl 11/28/2002 10:15'!
truncate: pos
	"Truncate to this position"

	self position: pos.
	^self primTruncate: handle to: pos! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'nice 10/12/2010 02:37'!
truncateTo: pos
	"This is a Xtreams friendly message"

	self position: pos.
	^self primTruncate: handle to: pos! !

!XTIOFileHandle methodsFor: 'accessing' stamp: 'nice 10/12/2010 20:44'!
writable
	^ writable! !

!XTIOFileHandle methodsFor: 'read, write, position' stamp: 'nice 10/12/2010 20:46'!
writeFrom: buffer startingAt: index count: num
	"Answer the number of bytes written"
	writable ifFalse: [self error: 'Cannot write a read-only file'. ^ 0].
	^self primWrite: self handle from: buffer startingAt: index count: num.! !

!XTIOFileHandle methodsFor: 'converting' stamp: 'nice 10/12/2010 03:09'!
writing
	^XTFileWriteStream on: self! !

!XTIOHandle classSide methodsFor: 'instance creation' stamp: 'dtl 11/13/1999 10:52'!
forFile: fileName forWrite: writeMode

	^ self forFiles new open: fileName forWrite: writeMode
! !

!XTIOHandle classSide methodsFor: 'concrete classes' stamp: 'dtl 7/17/2000 04:51'!
forFiles
	"Answer the subclass which represents file system objects."

	^ ConcreteFileClass! !

!XTIOHandle classSide methodsFor: 'concrete classes' stamp: 'dtl 7/17/2000 04:51'!
forSockets
	"Answer the subclass which represents network sockets."

	^ ConcreteSocketClass! !

!XTIOHandle classSide methodsFor: 'initialize-release' stamp: 'nice 10/12/2010 20:26'!
initialize
	self makeNonviewableInstances.
	Smalltalk addToShutDownList: self after: DisplayScreen! !

!XTIOHandle classSide methodsFor: 'initialize-release' stamp: 'nice 10/12/2010 20:42'!
makeNonviewableInstances
	"This is the normal mode of operation."

	"IOHandle makeNonviewableInstances"

	ConcreteFileClass := XTIOFileHandle.
	ConcreteSocketClass := XTIOSocketHandle! !

!XTIOHandle classSide methodsFor: 'system shutdown' stamp: 'nice 12/1/2009 20:12'!
shutDown: quitting 
	"Clean up and unregister all active instances. Do not close the system changes file,
	since this may still be written after calling this method."

	quitting
		ifTrue: [ | changesFile |
				changesFile := SourceFiles at: 2.
				self registry asArray do: [:e |
					changesFile isNil
						ifTrue: [e finalize; unregister]
						ifFalse: [(changesFile ioHandle ~= e) ifTrue: [e finalize; unregister]]]]
! !

!XTIOHandle methodsFor: 'finalization' stamp: 'nice 10/15/2010 20:28'!
finalize

	semaphore ifNotNil: [Smalltalk unregisterExternalObject: semaphore].
	self unregister
! !

!XTIOHandle methodsFor: 'initialize - release' stamp: 'nice 10/15/2010 20:30'!
initialize

	self register.
	semaphore ifNotNil: [semaphore terminateProcess].
"	self startSemaphoreProcess"
! !

!XTIOHandle methodsFor: 'accessing' stamp: 'nice 9/25/2010 20:53'!
semaphore
	"A semaphore which may be signalled by external events to support
	asynchronous input and output handling."

	^semaphore ifNil: [semaphore := Semaphore new]! !

!XTIOHandle methodsFor: 'asynchronous input' stamp: 'nice 10/15/2010 20:26'!
startSemaphoreProcess
	"Start a process to handle asynchronous input and output events."

	semaphore
		ifNotNil:
			[semaphore terminateProcess.
			semaphore := nil].
	self semaphore.
	[[self semaphore wait; initSignals] repeat]
		forkAt: Processor userBackgroundPriority! !

XTIOHandle subclass: #XTIOSocketHandle
	instanceVariableNames: 'socketType writeSemaphore readSemaphore primitiveOnlySupportsOneSemaphore'
	classVariableNames: 'Connected InvalidSocket OtherEndClosed TCPSocketType ThisEndClosed UDPSocketType Unconnected WaitingForConnection'
	poolDictionaries: ''
	category: 'Xtreams-Support'!

!XTIOSocketHandle commentStamp: 'dtl 11/28/2002 22:55' prior: 0!
I represent an IO channel on a network socket. I keep a ByteArray which corresponds
to an SQSocket data structure in the Squeak virtual machine.!

!XTIOSocketHandle classSide methodsFor: 'instance creation' stamp: 'dtl 11/11/2000 20:11'!
create: socketType

	^ self create: socketType network: 0
! !

!XTIOSocketHandle classSide methodsFor: 'instance creation' stamp: 'dtl 11/11/2000 20:11'!
create: socketType network: netType

	^ self create: socketType network: netType receiveBufferSize: 8000 sendBufSize: 8000
! !

!XTIOSocketHandle classSide methodsFor: 'instance creation' stamp: 'dtl 12/27/2000 10:53'!
create: socketType network: netType receiveBufferSize: rcvBufSize sendBufSize: sendBufSize

	^ super new
		initialize: socketType
		network: netType
		receiveBufferSize: rcvBufSize
		sendBufferSize: sendBufSize! !

!XTIOSocketHandle classSide methodsFor: 'instance creation' stamp: 'dtl 11/12/2000 11:35'!
createTCP

	^ self create: TCPSocketType
! !

!XTIOSocketHandle classSide methodsFor: 'instance creation' stamp: 'dtl 11/12/2000 11:35'!
createUDP

	^ self create: UDPSocketType
! !

!XTIOSocketHandle classSide methodsFor: 'class initialization' stamp: 'dtl 11/28/2002 12:04'!
initialize
	"IOSocketHandle initialize"

	"Socket Types"
	TCPSocketType := 0.
	UDPSocketType := 1.

	"Socket Status Values"
	InvalidSocket := -1.
	Unconnected := 0.
	WaitingForConnection := 1.
	Connected := 2.
	OtherEndClosed := 3.
	ThisEndClosed := 4.

	RegistryThreshold := 100. "# of sockets"
! !

!XTIOSocketHandle classSide methodsFor: 'private - converting' stamp: 'dtl 11/28/2002 22:51'!
socketTypeAsInteger: aSocketTypeSymbol
	"FIXME: The mapping of socket types to integers should be in class Socket. Socket has
	class variables for this, but no accessors. Somebody please gather this into one class,
	then update or elimitate this method."

	(aSocketTypeSymbol == #TCP) ifTrue: [^ TCPSocketType].
	(aSocketTypeSymbol == #UDP) ifTrue: [^ UDPSocketType].
	self error: 'invalid socket type, expected #TCP or #UDP'! !

!XTIOSocketHandle classSide methodsFor: 'private - converting' stamp: 'dtl 11/28/2002 22:49'!
socketTypeFromInteger: anInteger
	"FIXME: The mapping of socket types to integers should be in class Socket. Socket has
	class variables for this, but no accessors. Somebody please gather this into one class,
	then update or elimitate this method."

	(anInteger == TCPSocketType) ifTrue: [^ #TCP].
	(anInteger == UDPSocketType) ifTrue: [^ #UDP].
	self error: 'invalid socket type, should be ',
		TCPSocketType asString, ' or ', UDPSocketType asString! !

!XTIOSocketHandle methodsFor: 'connection open-close' stamp: 'nice 10/8/2010 00:28'!
abortConnection
	"Break this connection, no matter what state it is in. Data that has been sent but
	not received will be lost."

	self primSocketAbortConnection: handle.! !

!XTIOSocketHandle methodsFor: 'initialize-destroy' stamp: 'dtl 11/28/2002 15:18'!
acceptFrom: aSocketHandle
	"Initialize a new socket handle from an accept call"

	^ self acceptFrom: aSocketHandle receiveBufferSize: 8000 sendBufSize: 8000 
! !

!XTIOSocketHandle methodsFor: 'initialize-destroy' stamp: 'dtl 11/28/2002 15:17'!
acceptFrom: aSocketHandle receiveBufferSize: rbSize sendBufSize: sbSize 
	"Initialize a new socket handle from an accept call"
	| semaIndex readSemaIndex writeSemaIndex |

	semaphore := Semaphore new.
	readSemaphore := Semaphore new.
	writeSemaphore := Semaphore new.
	semaIndex := Smalltalk registerExternalObject: semaphore.
	readSemaIndex := Smalltalk registerExternalObject: readSemaphore.
	writeSemaIndex := Smalltalk registerExternalObject: writeSemaphore.
	handle := self primAcceptFrom: aSocketHandle
						receiveBufferSize: rbSize
						sendBufSize: sbSize
						semaIndex: semaIndex
						readSemaIndex: readSemaIndex
						writeSemaIndex: writeSemaIndex.
	handle = nil ifTrue: [  "socket creation failed"
		Smalltalk unregisterExternalObject: semaphore.
		Smalltalk unregisterExternalObject: readSemaphore.
		Smalltalk unregisterExternalObject: writeSemaphore.
		readSemaphore := writeSemaphore := semaphore := nil
	] ifFalse:[self register].
! !

!XTIOSocketHandle methodsFor: 'connection open-close' stamp: 'nice 10/8/2010 00:28'!
close
	"Close this connection gracefully. For TCP, this sends a close request, but the stream
	remains open until the other side also closes it."

	self primSocketCloseConnection: handle.  "close this end"
! !

!XTIOSocketHandle methodsFor: 'connection open-close' stamp: 'nice 10/8/2010 00:29'!
connectTo: hostAddress port: port
	"Initiate a connection to the given port at the given host address. This operation will
	return immediately; follow it with waitForConnectionUntil: to wait until the connection
	is established."

	self isUnconnected
		ifFalse: [self error: 'Socket status must be Unconnected before opening a new connection'].
	self primSocket: handle connectTo: hostAddress port: port.! !

!XTIOSocketHandle methodsFor: 'socket accessing' stamp: 'dtl 12/27/2000 01:05'!
connectionStatus

	^ self primSocketConnectionStatus: self handle.! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 12/27/2000 01:07'!
dataAvailable

	^ self primSocketReceiveDataAvailable: handle
! !

!XTIOSocketHandle methodsFor: 'utilities' stamp: 'nice 10/8/2010 00:36'!
deadlineSecs: secs
	"Return a deadline time the given number of seconds from now."

	^ Time millisecondClockValue + (secs * 1000) truncated
! !

!XTIOSocketHandle methodsFor: 'initialize-destroy' stamp: 'nice 10/8/2010 00:29'!
destroy
	"Destroy this socket. Its connection, if any, is aborted and its resources are freed. 
	Do nothing if the socket has already been destroyed (i.e., if its socketHandle is nil)."

	self isValid
		ifTrue: 
			[self primSocketDestroy: self handle].
	Smalltalk unregisterExternalObject: semaphore.
	Smalltalk unregisterExternalObject: readSemaphore.
	Smalltalk unregisterExternalObject: writeSemaphore.
	handle := nil.
	readSemaphore := writeSemaphore := semaphore := nil
! !

!XTIOSocketHandle methodsFor: 'sending-receiving' stamp: 'dtl 11/12/2000 22:06'!
discardReceivedData
	"Discard any data received up until now, and return the number of bytes discarded."

	| buf totalBytesDiscarded |
	buf := String new: 10000.
	totalBytesDiscarded := 0.
	[self isConnected and: [self dataAvailable]] whileTrue: [
		totalBytesDiscarded :=
			totalBytesDiscarded + (self receiveDataInto: buf)].
	^ totalBytesDiscarded
! !

!XTIOSocketHandle methodsFor: 'finalization' stamp: 'nice 10/8/2010 00:29'!
finalize

	super finalize.
	Smalltalk unregisterExternalObject: readSemaphore.
	Smalltalk unregisterExternalObject: writeSemaphore.
	self isValid
		ifTrue:
			[self primSocketDestroyGently: handle]

! !

!XTIOSocketHandle methodsFor: 'socket accessing' stamp: 'dtl 12/27/2000 01:05'!
getOption: aName 
	"Get options on this socket, see Unix man pages for values for 
	sockets, IP, TCP, UDP. IE SO_KEEPALIVE
	returns an array, element one is an status number (0 ok, -1 read only option)
	element two is the resulting of the requested option"

	^ self primSocket: self handle getOption: aName
! !

!XTIOSocketHandle methodsFor: 'accessing' stamp: 'dtl 12/27/2000 00:21'!
handle: aSqSocketStruct

	handle := aSqSocketStruct
! !

!XTIOSocketHandle methodsFor: 'initialize-destroy' stamp: 'dtl 11/11/2000 19:38'!
initialize: sockType
	"Initialize a new socket handle. If socket creation fails, socketHandle will be set to nil."

	^ self initialize: sockType network: 0 receiveBufferSize: 8000 sendBufferSize: 8000

! !

!XTIOSocketHandle methodsFor: 'initialize-destroy' stamp: 'dtl 11/28/2002 22:43'!
initialize: sockType network: netType receiveBufferSize: rBuf sendBufferSize: sBuf
	"Initialize a new socket handle. If socket creation fails, socketHandle will be set to nil."
	| semaIndex readSemaIndex writeSemaIndex |

	super initialize.
	semaphore := Semaphore new.
	readSemaphore := Semaphore new.
	writeSemaphore := Semaphore new.
	semaIndex := Smalltalk registerExternalObject: semaphore.
	readSemaIndex := Smalltalk registerExternalObject: readSemaphore.
	writeSemaIndex := Smalltalk registerExternalObject: writeSemaphore.
	socketType := self class socketTypeFromInteger: sockType.
	handle :=
		self primSocketCreateNetwork: netType
			type: sockType
			receiveBufferSize: rBuf
			sendBufSize: rBuf
			semaIndex: semaIndex
			readSemaIndex: readSemaIndex
			writeSemaIndex: writeSemaIndex.
	handle = nil ifTrue: [  "socket creation failed"
		Smalltalk unregisterExternalObject: semaphore.
		Smalltalk unregisterExternalObject: readSemaphore.
		Smalltalk unregisterExternalObject: writeSemaphore.
		readSemaphore := writeSemaphore := semaphore := nil]
! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 11/14/1999 12:59'!
isConnected
	"Return true if this socket is connected."

	^ self connectionStatus == Connected
! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 12/27/2000 01:06'!
isDestroyed
	"Return true if the socket has been destroyed."

	^ handle isNil
! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 12/27/2000 01:07'!
isOtherEndClosed
	"Return true if this socket had the other end closed."

	handle == nil ifTrue: [^ false].
	^ (self primSocketConnectionStatus: handle) == OtherEndClosed
! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 12/27/2000 01:07'!
isThisEndClosed
	"Return true if this socket had the this end closed."

	handle == nil ifTrue: [^ false].
	^ (self primSocketConnectionStatus: handle) == ThisEndClosed
! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 11/14/1999 13:00'!
isUnconnected
	"Return true if this socket's state is Unconnected."

	^ self connectionStatus == Unconnected
! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 11/14/1999 13:05'!
isUnconnectedOrInvalid
	"Return true if this socket is completely disconnected or is invalid."

	| status |
	status := self connectionStatus.
	^ (status == Unconnected) | (status == InvalidSocket)
! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 11/14/1999 13:01'!
isValid
	"Return true if this socket contains a valid, non-nil socket handle."

	^ self connectionStatus ~= InvalidSocket

! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 11/14/1999 13:01'!
isWaitingForConnection
	"Return true if this socket is waiting for a connection."

	^ self connectionStatus == WaitingForConnection
! !

!XTIOSocketHandle methodsFor: 'connection open-close' stamp: 'nice 10/8/2010 00:29'!
listenOn: port
	"Listen for a connection on the given port. This operation will return immediately;
	follow it with waitForConnectionUntil: to wait until a connection is established."

	| result |
	self isUnconnected
		ifFalse: [self error:
			'Socket status must be Unconnected before listening for a new connection'].
	result := self primSocket: handle listenOn: port.
	^ result
! !

!XTIOSocketHandle methodsFor: 'connection open-close' stamp: 'nice 10/8/2010 00:29'!
listenOn: portNumber backlogSize: backlog
	"Listen for a connection on the given port.
	If this method succeeds, #accept may be used to establish a new connection"

	| result |
	self isUnconnected
		ifFalse: [self error:
			'Socket status must be Unconnected before listening for a new connection'].
	result := self primSocket: handle listenOn: portNumber backlogSize: backlog.
	^ result
! !

!XTIOSocketHandle methodsFor: 'socket accessing' stamp: 'dtl 12/27/2000 01:05'!
localAddress

	^ self primSocketLocalAddress: self handle
! !

!XTIOSocketHandle methodsFor: 'socket accessing' stamp: 'dtl 12/27/2000 01:05'!
localPort

	^ self primSocketLocalPort: self handle
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 12:45'!
primAcceptFrom: IOSocketHandleID receiveBufferSize: rcvBufSize sendBufSize: sndBufSize semaIndex: semaIndex
	"Create and return a new IOSocketHandle based on accepting the connection from the given listening socket"

	<primitive: 'primitiveSocketAccept' module: 'SocketPlugin'>
	^self primitiveFailed! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 12:46'!
primAcceptFrom: ioSocketHandle receiveBufferSize: rcvBufSize sendBufSize: sndBufSize semaIndex: semaIndex readSemaIndex: aReadSema writeSemaIndex: aWriteSema
	"Create and return a new ioSocketHandle based on accepting the connection from the given listening socket"

	<primitive: 'primitiveSocketAccept3Semaphores' module: 'SocketPlugin'>
	primitiveOnlySupportsOneSemaphore := true.
	^self primAcceptFrom: ioSocketHandle receiveBufferSize: rcvBufSize sendBufSize: sndBufSize semaIndex: semaIndex ! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:33'!
primSocket: IOSocketHandleID connectTo: hostAddress port: port
	"Attempt to establish a connection to the given port of the given host. This is an asynchronous call; query the IOSocketHandle status to discover if and when the connection is actually completed."

	<primitive: 'primitiveSocketConnectToPort' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/11/2000 14:01'!
primSocket: IOSocketHandleID getOption: aString 
	"Get some option information on this socket. Refer to the UNIX 
	man pages for valid SO, TCP, IP, UDP options. In case of doubt
	refer to the source code.
	TCP_NODELAY, SO_KEEPALIVE are valid options for example
	returns an array containing the error code and the option value"

	<primitive: 'primitiveSocketGetOptions' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:01'!
primSocket: IOSocketHandleID listenOn: port
	"Listen for a connection on the given port. This is an asynchronous call; query the IOSocketHandle status to discover if and when the connection is actually completed."

	<primitive: 'primitiveSocketListenWithOrWithoutBacklog' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:01'!
primSocket: IOSocketHandleID listenOn: portNumber backlogSize: backlog
	"Primitive. Set up the socket to listen on the given port.
	Will be used in conjunction with #accept only."
	<primitive: 'primitiveSocketListenWithOrWithoutBacklog' module: 'SocketPlugin'>
	self destroy. "Accept not supported so clean up"! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:00'!
primSocket: IOSocketHandleID receiveDataInto: aStringOrByteArray startingAt: startIndex count: count
	"Receive data from the given IOSocketHandle into the given array starting at the given index. Return the number of bytes read or zero if no data is available."

	<primitive: 'primitiveSocketReceiveDataBufCount' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/11/2000 14:03'!
primSocket: IOSocketHandleID receiveUDPDataInto: aStringOrByteArray startingAt: startIndex count: count
	"Receive data from the given socket into the given array starting at the given index. 
	Return an Array containing the amount read, the host address byte array, the host port, and the more flag"

	<primitive: 'primitiveSocketReceiveUDPDataBufCount' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:00'!
primSocket: IOSocketHandleID sendData: aStringOrByteArray startIndex: startIndex count: count
	"Send data to the remote host through the given IOSocketHandle starting with the given byte index of the given byte array. The data sent is 'pushed' immediately. Return the number of bytes of data actually sent; any remaining data should be re-submitted for sending after the current send operation has completed."
	"Note: In general, it many take several sendData calls to transmit a large data array since the data is sent in send-buffer-sized chunks. The size of the send buffer is determined when the IOSocketHandle is created."

	<primitive: 'primitiveSocketSendDataBufCount' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/11/2000 14:03'!
primSocket: IOSocketHandleID sendUDPData: aStringOrByteArray toHost: hostAddress  port: portNumber startIndex: startIndex count: count
	"Send data to the remote host through the given socket starting with the given byte index of the given byte array. The data sent is 'pushed' immediately. Return the number of bytes of data actually sent; any remaining data should be re-submitted for sending after the current send operation has completed."
	"Note: In general, it many take several sendData calls to transmit a large data array since the data is sent in send-buffer-sized chunks. The size of the send buffer is determined when the socket is created."

	<primitive:  'primitiveSocketSendUDPDataBufCount' module: 'SocketPlugin'>
	self primitiveFailed

! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/11/2000 14:04'!
primSocket: IOSocketHandleID setOption: aString value: aStringValue
	"Set some option information on this socket. Refer to the UNIX 
	man pages for valid SO, TCP, IP, UDP options. In case of doubt
	refer to the source code.
	TCP_NODELAY, SO_KEEPALIVE are valid options for example
	returns an array containing the error code and the negotiated value"

	<primitive: 'primitiveSocketSetOptions' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:59'!
primSocket: IOSocketHandleID setPort: port
	"Set the local port associated with a UDP IOSocketHandle.
	Note: this primitive is overloaded.  The primitive will not fail on a TCP IOSocketHandle, but
	the effects will not be what was desired.  Best solution would be to split IOSocketHandle into
	two subclasses, TCPIOSocketHandle and UDPIOSocketHandle."

	<primitive: 'primitiveSocketListenWithOrWithoutBacklog' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:59'!
primSocketAbortConnection: IOSocketHandleID
	"Terminate the connection on the given port immediately without going through the normal close sequence. This is an asynchronous call; query the IOSocketHandle status to discover if and when the connection is actually terminated."

	<primitive: 'primitiveSocketAbortConnection' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 10:58'!
primSocketCloseConnection: IOSocketHandleID
	"Close the connection on the given port. The remote end is informed that this end has closed and will do no further sends. This is an asynchronous call; query the IOSocketHandle status to discover if and when the connection is actually closed."

	<primitive: 'primitiveSocketCloseConnection' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:05'!
primSocketConnectionStatus: IOSocketHandleID
	"Return an integer reflecting the connection status of this IOSocketHandle. For a list of possible values, see the comment in the 'initialize' method of this class. If the primitive fails, return a status indicating that the IOSocketHandle handle is no longer valid, perhaps because the Squeak image was saved and restored since the IOSocketHandle was created. (IOSocketHandles do not survive snapshots.)"

	<primitive: 'primitiveSocketConnectionStatus' module: 'SocketPlugin'>
	^ InvalidSocket
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:20'!
primSocketCreateNetwork: netType type: connectionType receiveBufferSize: rcvBufSize sendBufSize: sendBufSize semaIndex: semaIndex
	"Return a new socket handle for a socket of the given type and buffer sizes. Return nil if socket creation fails.
	The netType parameter is platform dependent and can be used to encode both the protocol type (IP, Xerox XNS, etc.) and/or the physical network interface to use if this host is connected to multiple networks. A zero netType means to use IP protocols and the primary (or only) network interface.
	The connectionType parameter specifies:
		0	reliable stream socket (TCP if the protocol is IP)
		1	unreliable datagram socket (UDP if the protocol is IP)
	The buffer size parameters allow performance to be tuned to the application. For example, a larger receive buffer should be used when the application expects to be receiving large amounts of data, especially from a host that is far away. These values are considered requests only; the underlying implementation will ensure that the buffer sizes actually used are within allowable bounds. Note that memory may be limited, so an application that keeps many sockets open should use smaller buffer sizes. Note the macintosh implementation ignores this buffer size. Also see setOption to get/set socket buffer sizes which allows you to set/get the current buffer sizes for reading and writing.
 	If semaIndex is > 0, it is taken to be the index of a Semaphore in the external objects array to be associated with this socket. This semaphore will be signalled when the socket status changes, such as when data arrives or a send completes. All processes waiting on the semaphore will be awoken for each such event; each process must then query the socket state to figure out if the conditions they are waiting for have been met. For example, a process waiting to send some data can see if the last send has completed."

	<primitive: 'primitiveSocketCreate' module: 'SocketPlugin'>
	^ nil  "socket creation failed"
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:48'!
primSocketCreateNetwork: netType type: sockType receiveBufferSize: rcvBufSize sendBufSize: sendBufSize semaIndex: semaIndex readSemaIndex: aReadSema writeSemaIndex: aWriteSema
	"See comment in primSocketCreateNetwork: with one semaIndex. However
	you should know that some implementations ignore the buffer size and
	this interface supports three semaphores,  one for open/close/listen and
	the other two for reading and writing"

	<primitive: 'primitiveSocketCreate3Semaphores' module: 'SocketPlugin'>
	self primitiveOnlySupportsOneSemaphore: true.
	^ self primSocketCreateNetwork: netType
			type: socketType
			receiveBufferSize: rcvBufSize
			sendBufSize: sendBufSize
			semaIndex: semaIndex! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:33'!
primSocketDestroy: IOSocketHandleID
	"Release the resources associated with this IOSocketHandle. If a connection is open, it is aborted."

	<primitive: 'primitiveSocketDestroy' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:34'!
primSocketDestroyGently: IOSocketHandleID
	"Release the resources associated with this IOSocketHandle. If a connection is open, it is aborted.
	Do not fail if the receiver is already closed."

	<primitive: 'primitiveSocketDestroy' module: 'SocketPlugin'>
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:34'!
primSocketError: IOSocketHandleID
	"Return an integer encoding the most recent error on this IOSocketHandle. Zero means no error."

	<primitive: 'primitiveSocketError' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:35'!
primSocketLocalAddress: IOSocketHandleID
	"Return the local host address for this IOSocketHandle."

	<primitive: 'primitiveSocketLocalAddress' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:35'!
primSocketLocalPort: IOSocketHandleID
	"Return the local port for this IOSocketHandle, or zero if no port has yet been assigned."

	<primitive: 'primitiveSocketLocalPort' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:35'!
primSocketReceiveDataAvailable: IOSocketHandleID
	"Return true if data may be available for reading from the current IOSocketHandle."

	<primitive: 'primitiveSocketReceiveDataAvailable' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:36'!
primSocketRemoteAddress: IOSocketHandleID
	"Return the remote host address for this IOSocketHandle, or zero if no connection has been made."

	<primitive: 'primitiveSocketRemoteAddress' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:36'!
primSocketRemotePort: IOSocketHandleID
	"Return the remote port for this IOSocketHandle, or zero if no connection has been made."

	<primitive: 'primitiveSocketRemotePort' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'primitive access' stamp: 'dtl 11/28/2002 11:37'!
primSocketSendDone: IOSocketHandleID
	"Return true if there is no send in progress on the current IOSocketHandle."

	<primitive: 'primitiveSocketSendDone' module: 'SocketPlugin'>
	self primitiveFailed
! !

!XTIOSocketHandle methodsFor: 'accessing' stamp: 'dtl 11/28/2002 11:31'!
primitiveOnlySupportsOneSemaphore

	^ primitiveOnlySupportsOneSemaphore ifNil: [primitiveOnlySupportsOneSemaphore := false]
! !

!XTIOSocketHandle methodsFor: 'accessing' stamp: 'dtl 11/28/2002 11:32'!
primitiveOnlySupportsOneSemaphore: trueOrFalse

	primitiveOnlySupportsOneSemaphore := trueOrFalse
! !

!XTIOSocketHandle methodsFor: 'printing' stamp: 'dtl 12/27/2000 01:10'!
printOn: aStream

	super printOn: aStream.
	socketType ifNotNil: [aStream nextPutAll: (' for ', socketType)].
"	aStream nextPutAll: ' ('.
	self handle inject: true into: [
		:first :e | 
		first ifFalse: [ aStream nextPut: Character space ].
		e printOn: aStream.
		false ].
	aStream nextPutAll: ')'"

! !

!XTIOSocketHandle methodsFor: 'accessing' stamp: 'dtl 11/28/2002 11:49'!
readSemaphore

	self primitiveOnlySupportsOneSemaphore
		ifTrue: [^ semaphore]
		ifFalse: [^ readSemaphore]! !

!XTIOSocketHandle methodsFor: 'accessing' stamp: 'dtl 11/11/2000 15:58'!
readSemaphore: aSemaphore

	readSemaphore := aSemaphore! !

!XTIOSocketHandle methodsFor: 'sending-receiving' stamp: 'dtl 11/12/2000 22:09'!
receiveDataInto: aStringOrByteArray
	"Receive data into the given buffer and return the number of bytes received. Note the
	given buffer may be only partially filled by the received data."

	^ self receiveDataInto: aStringOrByteArray
						startingAt: 1
						count: aStringOrByteArray size

! !

!XTIOSocketHandle methodsFor: 'datagrams' stamp: 'dtl 11/28/2002 11:49'!
receiveDataInto: aStringOrByteArray fromHost: hostAddress port: portNumber
	| datagram |
	"Receive a UDP packet from the given hostAddress/portNumber, storing the data in the given buffer, and return the number of bytes received. Note the given buffer may be only partially filled by the received data."

	self primitiveOnlySupportsOneSemaphore ifTrue:
		[self setPeer: hostAddress port: portNumber.
		^self receiveDataInto: aStringOrByteArray].
	[true] whileTrue: 
		[datagram := self receiveUDPDataInto: aStringOrByteArray.
		((datagram at: 2) = hostAddress and: [(datagram at: 3) = portNumber]) 
			ifTrue: [^datagram at: 1]
			ifFalse: [^0]]! !

!XTIOSocketHandle methodsFor: 'sending-receiving' stamp: 'dtl 12/27/2000 01:09'!
receiveDataInto: buf startingAt: index count: num
	"Receive up to num bytes of data into a buffer starting at the given index. Return
	the number of bytes read or zero if no data is available."

	^ self primSocket: handle
			receiveDataInto: buf
			startingAt: index
			count: num! !

!XTIOSocketHandle methodsFor: 'datagrams' stamp: 'dtl 12/27/2000 01:10'!
receiveUDPDataInto: aStringOrByteArray
	"Receive UDP data into the given buffer and return the number of bytes received. Note the given buffer may be only partially filled by the received data. What is returned is an array, the first element is the bytes read, the second the sending bytearray address, the third the senders port, the fourth, true if more of the datagram awaits reading"

	^ self primSocket: handle
		receiveUDPDataInto: aStringOrByteArray
		startingAt: 1
		count: aStringOrByteArray size
! !

!XTIOSocketHandle methodsFor: 'socket accessing' stamp: 'dtl 12/27/2000 01:05'!
remoteAddress

	^ self primSocketRemoteAddress: self handle
! !

!XTIOSocketHandle methodsFor: 'socket accessing' stamp: 'dtl 12/27/2000 01:06'!
remotePort

	^ self primSocketRemotePort: self handle
! !

!XTIOSocketHandle methodsFor: 'sending-receiving' stamp: 'dtl 12/27/2000 01:09'!
sendData: aStringOrByteArray startIndex: index count: num
	"Send data to the remote host through the given socket starting with the given
	byte index of the given byte array. The data sent is 'pushed' immediately.
	Return the number of bytes of data actually sent; any remaining data should
	be re-submitted for sending after the current send operation has completed."

	^self primSocket: handle
			sendData: aStringOrByteArray
			startIndex: index
			count: num! !

!XTIOSocketHandle methodsFor: 'datagrams' stamp: 'dtl 11/28/2002 11:49'!
sendData: aStringOrByteArray toHost: hostAddress port: portNumber
	"Send a UDP packet containing the given data to the specified host/port."

	self primitiveOnlySupportsOneSemaphore ifTrue:
		[self setPeer: hostAddress port: portNumber.
		^self sendData: aStringOrByteArray].
	^self sendUDPData: aStringOrByteArray toHost: hostAddress port: portNumber! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 12/27/2000 01:07'!
sendDone
	"Return true if the most recent send operation on this socket has completed."

	^ self primSocketSendDone: handle
! !

!XTIOSocketHandle methodsFor: 'datagrams' stamp: 'dtl 12/27/2000 01:10'!
sendUDPData: aStringOrByteArray toHost: hostAddress port: portNumber
	"Send a UDP packet containing the given data to the specified host/port."
	| bytesToSend bytesSent count |

	bytesToSend := aStringOrByteArray size.
	bytesSent := 0.
	[bytesSent < bytesToSend] whileTrue: [
		(self waitForSendDoneUntil: (self deadlineSecs: 20))
			ifFalse: [self error: 'send data timeout; data not sent'].
		count := self primSocket: handle
			sendUDPData: aStringOrByteArray
			toHost: hostAddress
			port: portNumber
			startIndex: bytesSent + 1
			count: bytesToSend - bytesSent.
		bytesSent := bytesSent + count].

	^ bytesSent
! !

!XTIOSocketHandle methodsFor: 'socket accessing' stamp: 'dtl 12/27/2000 01:06'!
setOption: aName value: aValue 
	| value |
	"setup options on this socket, see Unix man pages for values for 
	sockets, IP, TCP, UDP. IE SO_KEEPALIVE
	returns an array, element one is the error number
	element two is the resulting of the negotiated value.
	See getOption for list of keys"

	value := aValue asString.
	aValue == true ifTrue: [value := '1'].
	aValue == false ifTrue: [value := '0'].
	^ self primSocket: self handle setOption: aName value: value! !

!XTIOSocketHandle methodsFor: 'datagrams' stamp: 'nice 10/8/2010 00:29'!
setPeer: hostAddress port: port
	"Set the default send/recv address. Similar to connectTo:port:, but bypasses the
	check for isConnected, since a UDP socket appears connected always."

	self primSocket: handle connectTo: hostAddress port: port.! !

!XTIOSocketHandle methodsFor: 'datagrams' stamp: 'nice 10/8/2010 00:30'!
setPort: port
	"Associate a local port number with a UDP socket.  Not applicable to TCP sockets."

	self primSocket: handle setPort: port.
! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 12/27/2000 01:08'!
socketError

	^ self primSocketError: handle! !

!XTIOSocketHandle methodsFor: 'accessing' stamp: 'dtl 12/10/2000 17:15'!
socketType

	^ socketType
! !

!XTIOSocketHandle methodsFor: 'accessing' stamp: 'dtl 10/28/1999 11:10'!
socketType: aSymbol
	"aSymbol may be #TCP, #UDP etc."

	socketType := aSymbol! !

!XTIOSocketHandle methodsFor: 'utilities' stamp: 'dtl 11/12/2000 09:55'!
standardDeadline
	"Return a default deadline time some seconds into the future."

	^ self deadlineSecs: 45
! !

!XTIOSocketHandle methodsFor: 'queries' stamp: 'dtl 12/10/2000 17:45'!
statusString
	"Return a string describing the status of this socket."

	| status |
	status := self connectionStatus.
	status == InvalidSocket ifTrue: [^ 'invalidSocketHandle'].
	status == Unconnected ifTrue: [^ 'unconnected'].
	status == WaitingForConnection ifTrue: [^ 'waitingForConnection'].
	status == Connected ifTrue: [^ 'connected'].
	status == OtherEndClosed ifTrue: [^ 'otherEndClosedButNotThisEnd'].
	status == ThisEndClosed ifTrue: [^ 'thisEndClosedButNotOtherEnd'].
	self isDestroyed ifTrue: [^ 'destroyed'].
	^ 'unknown socket status'
! !

!XTIOSocketHandle methodsFor: 'updating' stamp: 'nice 10/8/2010 00:35'!
update: aParameter
	"Update the instance variables which depend on sqSocketStruct."

	self handle ifNotNil: [self socketType].
	^ super update: aParameter
! !

!XTIOSocketHandle methodsFor: 'waiting' stamp: 'dtl 11/12/2000 10:21'!
waitForAcceptUntil: deadLine
	"Wait and accept an incoming connection"

	self waitForConnectionUntil: deadLine.
	^self isConnected
		ifTrue:[self accept]
		ifFalse:[nil]! !

!XTIOSocketHandle methodsFor: 'waiting' stamp: 'nice 10/8/2010 00:30'!
waitForConnectionUntil: deadline
	"Wait up until the given deadline for a connection to be established. Return true if it is established by the deadline, false if not."

	[(self isWaitingForConnection) and: [Time millisecondClockValue < deadline]]
		whileTrue: [semaphore waitTimeoutMSecs: (deadline - Time millisecondClockValue)].
	^ self isConnected
! !

!XTIOSocketHandle methodsFor: 'waiting' stamp: 'nice 10/8/2010 00:30'!
waitForDataUntil: deadline
	"Wait up until the given deadline for data to arrive. Return true if data arrives by the deadline, false if not."

	| dataArrived |
	[self isConnected & 
	 (dataArrived := self primSocketReceiveDataAvailable: handle) not
			"Connection end and final data can happen fast, so test in this order"
		and: [Time millisecondClockValue < deadline]] whileTrue: [
			self readSemaphore waitTimeoutMSecs: (deadline - Time millisecondClockValue)].
	^ dataArrived
! !

!XTIOSocketHandle methodsFor: 'waiting' stamp: 'nice 10/8/2010 00:30'!
waitForDisconnectionUntil: deadline
	"Wait up until the given deadline for the the connection to be broken. Return true if it is broken by the deadline, false if not."
	"Note: The client should know the the connect is really going to be closed (e.g., because he has called 'close' to send a close request to the other end) before calling this method.
JMM 00/5/17 note that other end can close which will terminate wait"

	| extraBytes status |
	extraBytes := 0.
	status := self primSocketConnectionStatus: handle.
	[((status = Connected) or: [(status = ThisEndClosed)]) and:
	 [Time millisecondClockValue < deadline]] whileTrue: [
		self dataAvailable
			ifTrue: [extraBytes := extraBytes + self discardReceivedData].
		semaphore waitTimeoutMSecs: (deadline - Time millisecondClockValue).
		status := self primSocketConnectionStatus: handle].

	extraBytes > 0
		ifTrue: [self inform: 'Discarded ', extraBytes printString, ' bytes while closing connection.'].
	^ status ~= Connected! !

!XTIOSocketHandle methodsFor: 'waiting' stamp: 'nice 10/8/2010 00:30'!
waitForSendDoneUntil: deadline
	"Wait up until the given deadline for the current send operation to complete. Return true if it completes by the deadline, false if not."

	| sendDone |
	[self isConnected & (sendDone := self primSocketSendDone: handle) not
			"Connection end and final data can happen fast, so test in this order"
		and: [Time millisecondClockValue < deadline]] whileTrue: [
			self writeSemaphore waitTimeoutMSecs: (deadline - Time millisecondClockValue)].
	^ sendDone! !

!XTIOSocketHandle methodsFor: 'accessing' stamp: 'dtl 11/28/2002 11:49'!
writeSemaphore

	self primitiveOnlySupportsOneSemaphore
		ifTrue: [^ semaphore]
		ifFalse: [^ writeSemaphore]! !

!XTIOSocketHandle methodsFor: 'accessing' stamp: 'dtl 11/11/2000 15:58'!
writeSemaphore: aSemaphore

	writeSemaphore := aSemaphore! !

Object subclass: #XTRecyclingCenter
	instanceVariableNames: 'recycled mutex'
	classVariableNames: ''
	poolDictionaries: 'XTPools'
	category: 'Xtreams-Support'!

XTRecyclingCenter class
	instanceVariableNames: 'objectspace1 fixedspace1 objectspaceN fixedspaceN cacheSize'!

XTRecyclingCenter class
	instanceVariableNames: 'objectspace1 fixedspace1 objectspaceN fixedspaceN cacheSize'!

!XTRecyclingCenter classSide methodsFor: 'accessing' stamp: 'MartinKobetic 1/1/2011 15:57'!
defaultBufferSize

	^DefaultBufferSize! !

!XTRecyclingCenter classSide methodsFor: 'class initialization' stamp: 'nice 10/9/2010 19:41'!
initialize
	| cacheLimit |
	cacheSize := DefaultBufferSize.
	cacheLimit := 3.
	objectspace1 := self new initialize: cacheLimit.
	fixedspace1 := self new initialize: cacheLimit.
	objectspaceN := self new initialize: cacheLimit.
	fixedspaceN := self new initialize: cacheLimit! !

!XTRecyclingCenter classSide methodsFor: 'recycling' stamp: 'nice 10/9/2010 19:42'!
new: anInteger class: aClass
	anInteger == 1 ifTrue: [^objectspace1 new: anInteger class: aClass].
	anInteger == cacheSize ifTrue: [^objectspaceN new: anInteger class: aClass].
	^aClass withSize: anInteger! !

!XTRecyclingCenter classSide methodsFor: 'recycling' stamp: 'nice 10/9/2010 19:43'!
newInFixedSpace: anInteger class: aClass
	self error: 'not yet implemented in Squeak'! !

!XTRecyclingCenter classSide methodsFor: 'recycling' stamp: 'nice 10/9/2010 19:44'!
recycle: aCollection
	aCollection == nil ifTrue: [^nil].
	aCollection isFixedArgument
		ifTrue:
			[aCollection size == 1 ifTrue: [fixedspace1 recycle: aCollection].
			aCollection size == cacheSize ifTrue: [fixedspaceN recycle: aCollection]]
		ifFalse:
			[aCollection size == 1 ifTrue: [objectspace1 recycle: aCollection].
			aCollection size == cacheSize ifTrue: [objectspaceN recycle: aCollection]]! !

!XTRecyclingCenter classSide methodsFor: 'recycling' stamp: 'nice 10/9/2010 19:44'!
recycleBuffer: aBuffer
	aBuffer == nil ifTrue: [^nil].
	self recycle: aBuffer cache! !

!XTRecyclingCenter methodsFor: 'recycling' stamp: 'nice 10/9/2010 19:39'!
existing: aClass
	| queue collection |
	queue := recycled at: aClass.
	mutex critical: [
	1 to: queue size do: [:index |
		collection := queue at: index.
		collection == nil ifFalse:
			[queue at: index put: nil.
			^collection]]].
	^nil! !

!XTRecyclingCenter methodsFor: 'initialize-release' stamp: 'nice 10/9/2010 19:33'!
initialize: aCacheLimit
	mutex := Semaphore forMutualExclusion.
	recycled := IdentityDictionary new.
	SequenceableCollection allSubclassesDo: [:aClass | recycled at: aClass put: (Array new: aCacheLimit)]! !

!XTRecyclingCenter methodsFor: 'recycling' stamp: 'nice 10/9/2010 19:39'!
new: anInteger class: aClass
	| collection |
	(collection := self existing: aClass) == nil ifTrue: [collection := aClass withSize: anInteger].
	^collection! !

!XTRecyclingCenter methodsFor: 'recycling' stamp: 'nice 10/9/2010 19:40'!
newInFixedSpace: anInteger class: aClass
	self error: ' not yet implemented in Squeak '! !

!XTRecyclingCenter methodsFor: 'recycling' stamp: 'nice 10/9/2010 19:41'!
recycle: aCollection
	| queue |
	queue := recycled at: aCollection class.
	mutex critical: [
	1 to: queue size do: [:index |
		(queue at: index) == nil ifTrue:
			[queue at: index put: aCollection.
			^self]]].! !

!Number methodsFor: '*Xtreams-Support' stamp: 'ul 10/11/2010 04:03'!
milliseconds

	^self milliSeconds! !
XTPools initialize!
XTSqueakEncoder initialize!
XTIOHandle initialize!
XTIOSocketHandle initialize!
XTRecyclingCenter initialize!
